Adding files provided by Klaus Singvogel of Caldera
authorJohn Terpstra <jht@samba.org>
Sun, 30 Jul 2000 06:33:30 +0000 (06:33 +0000)
committerJohn Terpstra <jht@samba.org>
Sun, 30 Jul 2000 06:33:30 +0000 (06:33 +0000)
12 files changed:
packaging/Caldera/OpenLinux/convertsmbpasswd.perl [new file with mode: 0755]
packaging/Caldera/OpenLinux/findsmb [new file with mode: 0755]
packaging/Caldera/OpenLinux/make_smbpasswd.perl [new file with mode: 0755]
packaging/Caldera/OpenLinux/samba.daemon [new file with mode: 0644]
packaging/Caldera/OpenLinux/samba.init [new file with mode: 0755]
packaging/Caldera/OpenLinux/samba.logrotate [new file with mode: 0644]
packaging/Caldera/OpenLinux/samba.pam [new file with mode: 0644]
packaging/Caldera/OpenLinux/smb.conf.sample [new file with mode: 0644]
packaging/Caldera/OpenLinux/smbadduser.perl [new file with mode: 0755]
packaging/Caldera/OpenLinux/smbprint [new file with mode: 0755]
packaging/Caldera/OpenLinux/smbusers [new file with mode: 0644]
packaging/Caldera/OpenLinux/updatesmbpasswd.perl [new file with mode: 0755]

diff --git a/packaging/Caldera/OpenLinux/convertsmbpasswd.perl b/packaging/Caldera/OpenLinux/convertsmbpasswd.perl
new file mode 100755 (executable)
index 0000000..6b83886
--- /dev/null
@@ -0,0 +1,15 @@
+#!/usr/bin/perl -w
+#
+# Convert a Samba 1.9.18 smbpasswd file format into
+# a Samba 2.0 smbpasswd file format.
+# Read from stdin and write to stdout for simplicity.
+# Set the last change time to the time of conversion.
+while ( <> ) {
+  @V = split(/:/);
+  if ( ! /^\#/ ) {
+    $V[6] = $V[4] . "\n";
+    $V[5] = sprintf( "LCT-%X", time());
+    $V[4] = "[U          ]";
+  }
+  print( join( ':', @V));
+}
diff --git a/packaging/Caldera/OpenLinux/findsmb b/packaging/Caldera/OpenLinux/findsmb
new file mode 100755 (executable)
index 0000000..986c248
--- /dev/null
@@ -0,0 +1,141 @@
+#!/usr/bin/perl
+#
+# Prints info on all smb responding machines on a subnet.
+# This script needs to be run on a machine without nmbd running and be
+# run as root to get correct info from WIN95 clients.
+#
+# syntax:
+#    findsmb [subnet broadcast address]
+#
+# with no agrument it will list machines on the current subnet
+#
+# There will be a "+" in front of the workgroup name for machines that are
+# local master browsers for that workgroup. There will be an "*" in front
+# of the workgroup name for machines that are the domain master browser for
+# that workgroup.
+#
+
+$SAMBABIN = "/usr/bin";
+
+for ($i = 0; $i < 2; $i++) {   # test for -d option and broadcast address
+  $_ = shift;
+  if (m/-d|-D/) {
+    $DEBUG = 1;
+  } else  {
+    if ($_) {
+      $BCAST = "-B $_";
+    }
+  }
+}
+
+sub ipsort                     # do numeric sort on last field of IP address
+{
+  @t1 = split(/\./,$a);
+  @t2 = split(/\./,$b);
+  @t1[3] <=> @t2[3];
+}
+
+# look for all machines that respond to a name lookup
+
+open(NMBLOOKUP,"$SAMBABIN/nmblookup $BCAST '*'|") || 
+  die("Can't run nmblookup '*'.\n");
+
+# get rid of all lines that are not a response IP address,
+# strip everything but IP address and sort by last field in address
+
+@ipaddrs = sort ipsort grep(s/ \*<00>.*$//,<NMBLOOKUP>);
+
+# print header info
+
+print "\nIP ADDR         NETBIOS NAME   WORKGROUP/OS/VERSION $BCAST\n";
+print "---------------------------------------------------------------------\n";
+
+foreach $ip (@ipaddrs)         # loop through each IP address found
+{
+  $ip =~ s/\n//;               # strip newline from IP address
+
+# find the netbios names registered by each machine
+
+  open(NMBLOOKUP,"$SAMBABIN/nmblookup -r -A $ip|") || 
+       die("Can't get nmb name list.\n");
+  @nmblookup = <NMBLOOKUP>;
+  close NMBLOOKUP;
+
+# get the first <00> name
+
+  @name = grep(/<00>/,@nmblookup);
+  $_ = @name[0];
+  if ($_) {                     # we have a netbios name
+    if (/GROUP/) {             # is it a group name
+       ($name, $aliases, $type, $length, @addresses) = 
+       gethostbyaddr(pack('C4',split('\.',$ip)),2);
+       if (! $name) {                  # could not get name
+           $name = "unknown nis name";
+       }
+    } else {
+       /(\S+)/;
+       $name = $1;
+    }
+
+# do an smbclient command on the netbios name.
+
+    open(SMB,"$SAMBABIN/smbclient -N -L $name -I $ip -U% |") ||
+       die("Can't do smbclient command.\n");
+    @smb = <SMB>;
+    close SMB;
+
+    if ($DEBUG) {              # if -d flag print results of nmblookup and smbclient
+      print "===============================================================\n";
+      print @nmblookup;
+      print @smb;
+    }
+
+# look for the OS= string
+
+    @info = grep(/OS=/,@smb);
+    $_ = @info[0];
+    if ($_) {                          # we found response
+      s/Domain=|OS=|Server=|\n//g;     # strip out descriptions to make line shorter
+
+    } else {                           # no OS= string in response (WIN95 client)
+
+# for WIN95 clients get workgroup name from nmblookup response
+      @name = grep(/<00> - <GROUP>/,@nmblookup);
+      $_ = @name[0];
+      if ($_) {
+        /(\S+)/;
+        $_ = "[$1]";
+      } else {
+       $_ = "Unknown Workgroup";
+      }
+    }
+
+# see if machine registered a local master browser name
+    if (grep(/<1d>/,@nmblookup)) {
+      $master = '+';                   # indicate local master browser
+      if (grep(/<1b>/,@nmblookup)) {   # how about domain master browser?
+        $master = '*';                 # indicate domain master browser
+      }
+    } else {
+      $master = ' ';                   # not a browse master
+    }
+
+# line up info in 3 columns
+
+    print "$ip".' 'x(16-length($ip))."$name".' 'x(14-length($name))."$master"."$_\n";
+
+  } else {                             # no netbios name found
+# try getting the host name
+    ($name, $aliases, $type, $length, @addresses) = 
+      gethostbyaddr(pack('C4',split('\.',$ip)),2);
+    if (! $name) {                     # could not get name
+      $name = "unknown nis name";
+    }
+    if ($DEBUG) {                      # if -d flag print results of nmblookup
+      print "===============================================================\n";
+      print @nmblookup;
+    }
+    print "$ip".' 'x(16-length($ip))."$name\n";
+  }
+} 
+
diff --git a/packaging/Caldera/OpenLinux/make_smbpasswd.perl b/packaging/Caldera/OpenLinux/make_smbpasswd.perl
new file mode 100755 (executable)
index 0000000..2666c19
--- /dev/null
@@ -0,0 +1,13 @@
+#!/usr/bin/perl 
+$X= "X" x 32;
+$U="[U          ]";
+$L="LCT-00000000";
+print("#\n# SMB password file.\n#\n");
+
+while ( <> ) {
+  next unless (/^[A-Za-z0-9_]/);
+  chop;
+  @V = split(/:/);
+  printf( "%s:%s:%s:%s:%s:%s:%s\n", $V[0], $V[2], $X, $X, $U, $L, $V[4]);
+}
+
diff --git a/packaging/Caldera/OpenLinux/samba.daemon b/packaging/Caldera/OpenLinux/samba.daemon
new file mode 100644 (file)
index 0000000..9668370
--- /dev/null
@@ -0,0 +1,6 @@
+IDENT=samba
+DESCRIPTIVE="SMB server processes (samba)"
+CONFIGURED="no"
+ONBOOT="no"
+OPTIONS_SMB="-D"
+OPTIONS_NMB="-D"
diff --git a/packaging/Caldera/OpenLinux/samba.init b/packaging/Caldera/OpenLinux/samba.init
new file mode 100755 (executable)
index 0000000..1b830a1
--- /dev/null
@@ -0,0 +1,62 @@
+#!/bin/sh
+#
+# description: Starts and stops the Samba smbd and nmbd daemons
+#             used to provide SMB network services.
+
+NAME_S=smbd
+DAEMON_S=/usr/sbin/$NAME_S
+NAME_N=nmbd
+DAEMON_N=/usr/sbin/$NAME_N
+
+# Source function library.
+. /etc/rc.d/init.d/functions
+
+# Source networking configuration.
+. /etc/sysconfig/network
+
+# See how we were called.
+case "$1" in
+ start)
+  [ -e $SVIlock ] && exit 1
+  [ ${NETWORKING} = "no" ] && exit 2
+  [ -x $DAEMON_S -a -x $DAEMON_N ] || exit 2
+
+  #[ "$CONFIGURED"  != "no" -a "$CONFIGURED"  != "false" ] || {
+  SVIemptyConfig /etc/samba.d/smb.conf && {
+    echo "$DESCRIPTIVE: not configured! Skipped..."
+    exit 2
+  }
+
+  echo -n "Starting $IDENT: "
+  ssd -S -n $NAME_S -x $DAEMON_S -- $OPTIONS_SMB
+  ssd -S -n $NAME_N -x $DAEMON_N -- $OPTIONS_NMB
+
+  echo "."
+  touch $SVIlock
+  ;;
+
+ stop)
+  [ -e $SVIlock ] || exit 0
+
+  echo -n "Stopping $IDENT: "
+  ssd -K -p /var/lock/samba.d/$NAME_N.pid -n $NAME_N #-x $DAEMON_N
+  ssd -K -p /var/lock/samba.d/$NAME_S.pid -n $NAME_S #-x $DAEMON_S
+
+  echo "."
+  rm -f $SVIlock
+  ;;
+
+ restart)
+  echo -n "Restarting $IDENT: "
+  $0 stop
+  $0 start
+  exit $?
+  ;;
+
+ *)
+  echo "Usage: $SVIscript {start|restart|stop}"
+  exit 1
+  ;;
+esac
+
+exit 0
diff --git a/packaging/Caldera/OpenLinux/samba.logrotate b/packaging/Caldera/OpenLinux/samba.logrotate
new file mode 100644 (file)
index 0000000..46611f8
--- /dev/null
@@ -0,0 +1,12 @@
+/var/log/samba.d/nmbd {
+    postrotate
+      /usr/bin/killall -HUP nmbd
+    endscript
+}
+
+/var/log/samba.d/smbd {
+    postrotate
+      /usr/bin/killall -HUP smbd
+    endscript
+}
+
diff --git a/packaging/Caldera/OpenLinux/samba.pam b/packaging/Caldera/OpenLinux/samba.pam
new file mode 100644 (file)
index 0000000..4588db1
--- /dev/null
@@ -0,0 +1,7 @@
+#%PAM-1.0
+#[For version 1.0 syntax, the above header is optional]
+#
+# The PAM configuration file for the `samba' service
+#
+auth       required     /lib/security/pam_pwdb.so shadow nullok
+account    required     /lib/security/pam_pwdb.so
diff --git a/packaging/Caldera/OpenLinux/smb.conf.sample b/packaging/Caldera/OpenLinux/smb.conf.sample
new file mode 100644 (file)
index 0000000..a00803c
--- /dev/null
@@ -0,0 +1,312 @@
+# This is the main Samba configuration file. You should read the
+# smb.conf(5) manual page in order to understand the options listed
+# here. Samba has a huge number of configurable options (perhaps too
+# many!) most of which are not shown in this example
+#
+# Any line which starts with a ; (semi-colon) or a # (hash) 
+# is a comment and is ignored. In this example we will use a #
+# for commentry and a ; for parts of the config file that you
+# may wish to enable
+#
+# NOTE: Whenever you modify this file you should run the command "testparm"
+# to check that you have not many any basic syntactic errors. 
+#
+#======================= Global Settings =====================================
+[global]
+
+# workgroup = NT-Domain-Name or Workgroup-Name
+   workgroup = WORKGROUP
+
+# server string is the equivalent of the NT Description field
+   server string = Samba Server on Caldera OpenLinux
+
+# This option is important for security. It allows you to restrict
+# connections to machines which are on your local network. The
+# following example restricts access to two C class networks and
+# the "loopback" interface. For more examples of the syntax see
+# the smb.conf man page
+;   hosts allow = 192.168.1. 192.168.2. 127.
+
+# If you want to automatically load your printer list rather
+# than setting them up individually then you'll need this
+   load printers = yes
+
+# you may wish to override the location of the printcap file
+;   printcap name = /etc/printcap
+
+# It should not be necessary to specify the print system type unless
+# it is non-standard. Currently supported print systems include:
+# bsd, sysv, plp, lprng, aix, hpux, qnx
+   printing = lprng
+
+# Uncomment this if you want a guest account, you must add this to /etc/passwd
+# otherwise the user "nobody" is used
+;  guest account = pcguest
+
+# this tells Samba to use a separate log file for each machine
+# that connects
+;  log file = /var/log/samba.d/smb.%m
+
+# Put a capping on the size of the log files (in Kb).
+   max log size = 50
+
+# Security mode. Most people will want user level security. See
+# security_level.txt for details.
+   security = user
+# Use password server option only with security = server
+;   password server = <NT-Server-Name>
+
+# Password Level allows matching of _n_ characters of the password for
+# all combinations of upper and lower case.
+;  password level = 8
+;  username level = 8
+
+# You may wish to use password encryption. Please read
+# ENCRYPTION.txt, Win95.txt and WinNT.txt in the Samba documentation.
+# Do not enable this option unless you have read those documents
+;  encrypt passwords = yes
+;  smb passwd file = /etc/samba.d/smbpasswd
+
+# The following are needed to allow password changing from Windows to
+# update the Linux sytsem password also.
+# NOTE: Use these with 'encrypt passwords' and 'smb passwd file' above.
+# NOTE2: You do NOT need these to allow workstations to change only
+#        the encrypted SMB passwords. They allow the Unix password
+#        to be kept in sync with the SMB password.
+;  unix password sync = Yes
+;  passwd program = /usr/bin/passwd %u
+;  passwd chat = *New*UNIX*password* %n\n *ReType*new*UNIX*password* %n\n *passwd:*all*authentication*tokens*updated*successfully*
+
+# Unix users can map to different SMB User names
+;  username map = /etc/samba.d/smbusers
+
+# Using the following line enables you to customise your configuration
+# on a per machine basis. The %m gets replaced with the netbios name
+# of the machine that is connecting
+;   include = /etc/samba.d/smb.conf.%m
+
+# Most people will find that this option gives better performance.
+# See speed.txt and the manual pages for details
+   socket options = TCP_NODELAY 
+
+# Configure Samba to use multiple interfaces
+# If you have multiple network interfaces then you must list them
+# here. See the man page for details.
+;   interfaces = 192.168.12.2/24 192.168.13.2/24 
+
+# Configure remote browse list synchronisation here
+#  request announcement to, or browse list sync from:
+#      a specific host or from / to a whole subnet (see below)
+;   remote browse sync = 192.168.3.25 192.168.5.255
+# Cause this host to announce itself to local subnets here
+;   remote announce = 192.168.1.255 192.168.2.44
+
+# Browser Control Options:
+# set local master to no if you don't want Samba to become a master
+# browser on your network. Otherwise the normal election rules apply
+;   local master = no
+
+# OS Level determines the precedence of this server in master browser
+# elections. The default value should be reasonable
+;   os level = 33
+
+# Domain Master specifies Samba to be the Domain Master Browser. This
+# allows Samba to collate browse lists between subnets. Don't use this
+# if you already have a Windows NT domain controller doing this job
+;   domain master = yes 
+
+# Preferred Master causes Samba to force a local browser election on startup
+# and gives it a slightly higher chance of winning the election
+;   preferred master = yes
+
+# Use only if you have an NT server on your network that has been
+# configured at install time to be a primary domain controller.
+;   domain controller = <NT-Domain-Controller-SMBName>
+
+# Enable this if you want Samba to be a domain logon server for 
+# Windows95 workstations. 
+;   domain logons = yes
+
+# if you enable domain logons then you may want a per-machine or
+# per user logon script
+# run a specific logon batch file per workstation (machine)
+;   logon script = %m.bat
+# run a specific logon batch file per username
+;   logon script = %U.bat
+
+# Where to store roving profiles (only for Win95 and WinNT)
+#        %L substitutes for this servers netbios name, %U is username
+#        You must uncomment the [Profiles] share below
+;   logon path = \\%L\Profiles\%U
+
+# All NetBIOS names must be resolved to IP Addresses
+# 'Name Resolve Order' allows the named resolution mechanism to be specified
+# the default order is "host lmhosts wins bcast". "host" means use the unix
+# system gethostbyname() function call that will use either /etc/hosts OR
+# DNS or NIS depending on the settings of /etc/host.config, /etc/nsswitch.conf
+# and the /etc/resolv.conf file. "host" therefore is system configuration
+# dependant. This parameter is most often of use to prevent DNS lookups
+# in order to resolve NetBIOS names to IP Addresses. Use with care!
+# The example below excludes use of name resolution for machines that are NOT
+# on the local network segment
+# - OR - are not deliberately to be known via lmhosts or via WINS.
+; name resolve order = wins lmhosts bcast
+
+# Windows Internet Name Serving Support Section:
+# WINS Support - Tells the NMBD component of Samba to enable it's WINS Server
+;   wins support = yes
+
+# WINS Server - Tells the NMBD components of Samba to be a WINS Client
+#      Note: Samba can be either a WINS Server, or a WINS Client, but NOT both
+;   wins server = w.x.y.z
+
+# WINS Proxy - Tells Samba to answer name resolution queries on
+# behalf of a non WINS capable client, for this to work there must be
+# at least one WINS Server on the network. The default is NO.
+;   wins proxy = yes
+
+# DNS Proxy - tells Samba whether or not to try to resolve NetBIOS names
+# via DNS nslookups. The built-in default for versions 1.9.17 is yes,
+# this has been changed in version 1.9.18 to no.
+   dns proxy = no 
+
+# Case Preservation can be handy - system default is _no_
+# NOTE: These can be set on a per share basis
+;  preserve case = no
+;  short preserve case = no
+# Default case is normally upper case for all DOS files
+;  default case = lower
+# Be very careful with case sensitivity - it can break things!
+;  case sensitive = no
+
+#============================ Share Definitions ==============================
+[homes]
+   comment = Home Directories
+; this gives access to a 'Public' sub-directory in each user's home...
+; (it is named 'public' as it is intended to be used by other sharing
+; technologies (like NetWare, appletalk) too and may get disclosed due
+; to weak protocols! -- hmm, are there less secure protocols than NFS? :)
+   path = %H/Public
+   valid users = %S
+   only user = yes
+   browseable = no
+   writable = yes
+   create mask = 0750
+
+# Un-comment the following and create the netlogon directory for Domain Logons
+; [netlogon]
+;   comment = Samba Network Logon Service
+;   path = /home/samba/netlogon
+;   guest ok = yes
+;   writable = no
+;   share modes = no
+
+
+# Un-comment the following to provide a specific roving profile share
+# the default is to use the user's home directory
+;[Profiles]
+;    path = /home/samba/profiles
+;    browseable = no
+;    guest ok = yes
+
+
+# NOTE: If you have a BSD-style print system there is no need to 
+# specifically define each individual printer
+[printers]
+   comment = All Printers
+   path = /var/spool/samba
+   browseable = no
+# Set public = yes to allow user 'guest account' to print
+   guest ok = no
+   writable = no
+   printable = yes
+   create mask = 0700
+
+# A publicly accessible directory, but read only, except for people in
+# the "users" group
+;[public]
+;   comment = Public Stuff
+;   path = /home/public
+;   browseable = yes
+;   public = yes
+;   writable = yes
+;   printable = no
+# access may be controlled by these options
+;  read list = user1, user2, @group
+;  valid users = user1, user3
+;   write list = @users
+
+# Other examples. 
+#
+# This one is useful for people to share files, BUT
+# access to '/tmp' or '/var/tmp' should *not* be given lightly,
+# as this can (still) pose a security threat!
+# Better use a dedicate sub-directory to /(var/)tmp or something
+# like a [public] share!
+[tmp]
+   comment = Temporary file space
+   path = /tmp
+   browseable = yes
+   read only = yes
+   public = no
+   printable = no
+
+# A private printer, usable only by fred. Spool data will be placed in fred's
+# home directory. Note that fred must have write access to the spool directory,
+# wherever it is.
+;[fredsprn]
+;   comment = Fred's Printer
+;   valid users = fred
+;   path = /homes/fred
+;   printer = freds_printer
+;   public = no
+;   writable = no
+;   printable = yes
+
+# A private directory, usable only by fred. Note that fred requires write
+# access to the directory.
+;[fredsdir]
+;   comment = Fred's Service
+;   path = /usr/somewhere/private
+;   valid users = fred
+;   public = no
+;   writable = yes
+;   printable = no
+
+# a service which has a different directory for each machine that connects
+# this allows you to tailor configurations to incoming machines. You could
+# also use the %u option to tailor it by user name.
+# The %m gets replaced with the machine name that is connecting.
+;[pchome]
+;  comment = PC Directories
+;  path = /usr/pc/%m
+;  public = no
+;  writable = yes
+
+# A publicly accessible directory, read/write to all users. Note that all files
+# created in the directory by users will be owned by the default user, so
+# any user with access can delete any other user's files. Obviously this
+# directory must be writable by the default user. Another user could of course
+# be specified, in which case all files would be owned by that user instead.
+;[public]
+;   path = /usr/somewhere/else/public
+;   public = yes
+;   only guest = yes
+;   writable = yes
+;   printable = no
+
+# The following two entries demonstrate how to share a directory so that two
+# users can place files there that will be owned by the specific users. In this
+# setup, the directory should be writable by both users and should have the
+# sticky bit set on it to prevent abuse. Obviously this could be extended to
+# as many users as required.
+;[myshare]
+;   comment = Mary's and Fred's stuff
+;   path = /usr/somewhere/shared
+;   valid users = mary fred
+;   public = no
+;   writable = yes
+;   printable = no
+;   create mask = 0765
+
+
diff --git a/packaging/Caldera/OpenLinux/smbadduser.perl b/packaging/Caldera/OpenLinux/smbadduser.perl
new file mode 100755 (executable)
index 0000000..61bec23
--- /dev/null
@@ -0,0 +1,146 @@
+#!/usr/bin/perl -w
+#
+# smbadduser - Written by Mike Zakharoff
+#              perl-rewrite by Raymund Will
+#
+
+$smbpasswd = "/etc/samba.d/smbpasswd";
+$user_map  = "/etc/samba.d/smbusers";
+#
+# Set to site specific passwd command
+#
+$passwd    = "cat /etc/passwd |";
+#$passwd    = "niscat passwd.org_dir |";
+if ( -e "/var/run/ypbind.pid" ) {
+  $passwd    = "(cat /etc/passwd; ypcat passwd ) |";
+}
+
+$line = "-" x 58;
+if ($#ARGV < 0) {
+  print <<EoM;
+$line
+Written: Mike Zakharoff email: michael.j.zakharoff\@boeing.com
+
+   1) Updates $smbpasswd
+   2) Updates $user_map
+   3) Executes smbpasswd for each new user
+
+smbadduser unixid[:ntid] unixid[:ntid] ...
+
+Example: smbadduser zak:zakharoffm jdoe johns:smithj
+$line
+EoM
+  exit 1;
+}
+
+# get valid UNIX-Ids (later skip missing)
+%U = ();
+{
+  my $X = "X" x 32;
+  my @t = ();
+  
+  open( IN, $passwd) || die( "ERROR: open($passwd): $!\n");
+  while ( <IN> ) {
+    next unless (/^[A-Za-z0-9_]+:/);
+    @t = split(/:/);
+    $U{$t[0]} = join( ":", ($t[0], $t[2], $X, $X, $t[4], $t[5], $t[6]));
+  }
+  close( IN);
+}
+# get all smb passwords (later skip already existent)
+%S = ();
+$Cs = "";
+if ( -r $smbpasswd ) {
+  open( IN, $smbpasswd) || die( "ERROR: open($smbpasswd): $!\n");
+  while ( <IN> ) {
+    if ( /^\#/ ) {
+      $Cs .= $_;  next;
+    } elsif ( ! /^([A-Za-z0-9_]+):/ ) {
+      chop; print STDERR "ERROR: $_: invalid smbpasswd entry!\n"; next;
+    }
+    $S{$1} = $_;
+  }
+  close( IN);
+}
+# get all map entries
+%M = ();
+$Cm = "";
+if ( -r $user_map ) {
+  open( IN, $user_map) || die( "ERROR: open($user_map): $!\n");
+  while ( <IN> ) {
+    if ( /^\#/ ) {
+      $Cm .= $_;  next;
+    } elsif ( ! /^([A-Za-z0-9_]+)\s*=\s*(\S.+\S)\s*/ ) {
+      chop; print STDERR "ERROR: $_: invalid user-map entry!\n"; next;
+    }
+    $M{$1} = $2;
+  }
+  close( IN);
+}
+# check parameter syntax
+%N = ();
+{
+  foreach ( @ARGV ) {
+    my ( $u, $s, @R) = split(/:/);
+    if (  $#R >= 0 ) {
+      print STDERR "ERROR: $_: Must use unixid[:ntid] SKIPPING...\n";
+      next;
+    }
+    $s = $u unless ( defined( $s) );
+    if ( ! exists( $U{$u}) ) {
+      print STDERR "ERROR: $u: Not in passwd database SKIPPING...\n";
+      next;
+    }
+    if ( exists( $S{$u}) ) {
+      print STDERR "ERROR: $u: Already in smbpasswd database SKIPPING...\n";
+      next;
+    }
+    print  "Adding: $u to $smbpasswd\n";
+    $S{$u} = $U{$u};
+    if ( $u ne $s ) {
+      if ( exists( $M{$u}) ) {
+       if ( $M{$u} !~ /\b$s\b/ ) {
+         print "Adding: $s to $u in $user_map\n";
+         $M{$u} .= " $s";
+       }
+      } else {
+       print "Mapping: $s to $u in $user_map\n";
+       $M{$u} = $s;
+      }
+    }
+    $N{$u} = $s;
+  }
+}
+# rewrite $smbpasswd
+{
+  open( OUT, "> $smbpasswd.new")  || die( "ERROR: open($smbpasswd.new): $!\n");
+  $Cs = "#\n# SMB password file.\n#\n" unless ( $Cs );
+  print OUT $Cs;
+  foreach ( sort( keys( %S)) ) {
+    print OUT $S{$_};
+  }
+  close( OUT);
+  rename( $smbpasswd, $smbpasswd . "-");
+  rename( $smbpasswd . ".new", $smbpasswd) || die;
+}
+# rewrite $user_map
+{
+  open( OUT, "> $user_map.new")  || die( "ERROR: open($user_map.new): $!\n");
+  $Cm = "# Unix_name = SMB_name1 SMB_name2 ...\n" unless ( $Cm );
+  print OUT $Cm;
+  foreach ( sort( keys( %M)) ) {
+    print OUT "$_ = $M{$_}\n";
+  }
+  close( OUT);
+  rename( $user_map, $user_map . "-");
+  rename( $user_map . ".new", $user_map) || die;
+}
+# call 'smbpasswd' for each new
+{
+  foreach ( sort( keys( %N)) ) {
+    print $line . "\n";
+    print "ENTER password for $_\n";
+    system( "smbpasswd $_");
+  }
+}
+
diff --git a/packaging/Caldera/OpenLinux/smbprint b/packaging/Caldera/OpenLinux/smbprint
new file mode 100755 (executable)
index 0000000..5d66aa1
--- /dev/null
@@ -0,0 +1,77 @@
+#!/bin/sh
+
+# This script is an input filter for printcap printing on a unix machine. It
+# uses the smbclient program to print the file to the specified smb-based 
+# server and service.
+# For example you could have a printcap entry like this
+#
+# smb:lp=/dev/null:sd=/usr/spool/smb:sh:if=/usr/local/samba/smbprint
+#
+# which would create a unix printer called "smb" that will print via this 
+# script. You will need to create the spool directory /usr/spool/smb with
+# appropriate permissions and ownerships for your system.
+
+# Set these to the server and service you wish to print to 
+# In this example I have a WfWg PC called "lapland" that has a printer 
+# exported called "printer" with no password.
+
+#
+# Script further altered by hamiltom@ecnz.co.nz (Michael Hamilton)
+# so that the server, service, and password can be read from 
+# a /var/spool/lpd/PRINTNAME/.config file.
+#
+# In order for this to work the /etc/printcap entry must include an 
+# accounting file (af=...):
+#
+#   cdcolour:\
+#      :cm=CD IBM Colorjet on 6th:\
+#      :sd=/var/spool/lpd/cdcolour:\
+#      :af=/var/spool/lpd/cdcolour/acct:\
+#      :if=/usr/local/etc/smbprint:\
+#      :mx=0:\
+#      :lp=/dev/null:
+#
+# The /usr/var/spool/lpd/PRINTNAME/.config file should contain:
+#   server=PC_SERVER
+#   service=PR_SHARENAME
+#   password="password"
+#
+# E.g.
+#   server=PAULS_PC
+#   service=CJET_371
+#   password=""
+
+#
+# Debugging log file, change to /dev/null if you like.
+#
+# logfile=/tmp/smb-print.log
+logfile=/dev/null
+
+
+#
+# The last parameter to the filter is the accounting file name.
+#   Extract the directory name from the file name.
+#   Concat this with /.config to get the config file.
+#
+eval acct_file=\${$#}
+spool_dir=`dirname $acct_file` 
+config_file=$spool_dir/.config
+
+# Should read the following variables set in the config file:
+#   server
+#   service
+#   password
+eval `cat $config_file`
+
+#
+# Some debugging help, change the >> to > if you want to save space.
+#
+echo "server $server, service $service" >> $logfile
+
+(
+# NOTE You may wish to add the line `echo translate' if you want automatic
+# CR/LF translation when printing.
+#       echo translate
+       echo "print -"
+       cat
+) | /usr/bin/smbclient "//$server/$service" $password -U $server -N -P >> $logfile 2>&1
diff --git a/packaging/Caldera/OpenLinux/smbusers b/packaging/Caldera/OpenLinux/smbusers
new file mode 100644 (file)
index 0000000..ae3389f
--- /dev/null
@@ -0,0 +1,3 @@
+# Unix_name = SMB_name1 SMB_name2 ...
+root = administrator admin
+nobody = guest pcguest smbguest
diff --git a/packaging/Caldera/OpenLinux/updatesmbpasswd.perl b/packaging/Caldera/OpenLinux/updatesmbpasswd.perl
new file mode 100755 (executable)
index 0000000..60f572b
--- /dev/null
@@ -0,0 +1,10 @@
+#!/usr/bin/perl -w
+while ( <> ) {
+  print;
+  @V = split(/:/);
+  $_ = $V[3];
+  if ( $V[0] !~ /^\#/ && !(/^[0-9A-F]{32}$/ || /^X{32}$/ || /^\*{32}$/) ) {
+    $V[3] = "X" x 32;
+  }
+  print( join( ':', @V));
+}